#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<int> bfs(int u, vector< vector<int> >& g) {
	vector<int> d(g.size(), -1);
	d[u] = 0;

	queue<int> q;
	q.push(u);
	while(!q.empty()) {
		int t = q.front(); q.pop();

		for(int v : g[t])
			if(d[v] == -1) {
				d[v] = d[t] + 1;
				q.push(v);
			}
	}

	return d;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > g(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	int u;
	cin >> u;

	vector<int> udaljenosti = bfs(u, g);

	for(int d : udaljenosti)
		cout << d << ' ';
	cout << '\n';

	return 0;
}
